using System;
using System.Reflection;

namespace MultiColumnTree
{
	/// <summary>
	/// The invoker class uses the reflection to set and get a property by name.
	/// </summary>
	public class Invoker
	{
		public Invoker()
		{
		}
		static public void SetProperty(object obj, string propertyName, object[] args) {
			if (obj != null) {
				Type t = obj.GetType();
				PropertyInfo pi = t.GetProperty(propertyName);
				if (pi != null) {
					MethodInfo mi = pi.GetSetMethod();
					if (mi != null) 
						mi.Invoke(obj, args); // control -> object
				}
			}
		}
		static public object GetProperty(object obj, string propertyName) {
			if (obj != null) {
				Type t = obj.GetType();
				PropertyInfo pi = t.GetProperty(propertyName);
				if (pi != null) {
					MethodInfo mi = pi.GetGetMethod();
					if (mi != null) {
						return mi.Invoke(obj, new object[]{});
					}
				}
			}
			return null;
		}

	}
}
