using System;
using System.Windows.Forms;
using System.Drawing;
using System.ComponentModel;
using System.Collections;
using System.Diagnostics;

namespace MultiColumnTree
{
	/// <summary>
	/// TreeLabel inherit from class label. 
	/// Treelabel has additional properties, WidthMin and PropertyName
	/// </summary>
	public class TreeLabel : Label
	{
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TreeLabel(System.ComponentModel.IContainer container)
		{
			///
			/// Erforderlich fr Windows.Forms Klassenkompositions-Designeruntersttzung
			///
			container.Add(this);
			InitializeComponent();
		}

		public TreeLabel() : base()
		{
			///
			/// Erforderlich fr Windows.Forms Klassenkompositions-Designeruntersttzung
			///
			InitializeComponent();
			gr = this.CreateGraphics();
			this.TextChanged += new EventHandler(TreeLabel_TextChanged);
		}

		/// <summary> 
		/// Verwendete Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Vom Komponenten-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion


		/// <summary>
		/// Need for width calculation
		/// </summary>
		private Graphics gr;

		/// <summary>
		/// Minimal width in pixel
		/// </summary>
		private int widthMin;
		public int WidthMin {
			set {widthMin = value;}
			get {return widthMin;}
		}
		/// <summary>
		/// Property namein class source to set the label text
		/// </summary>
		private string propertyName;
		public string PropertyName {
			set {propertyName = value;}
			get {return propertyName;}
		}

		/// <summary>
		/// Calculate the width when text has changed
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void TreeLabel_TextChanged(object sender, System.EventArgs e) {
			widthMin = Convert.ToInt32(gr.MeasureString(this.Text, this.Font).Width) + 3;
			//Console.WriteLine(this.Text);
		}
		public object Source {
			get {return ((MCTNode)this.Tag).Source;}
		}
	}
}
